/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */

/*
 * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#pragma ident	"%Z%%M%	%I%	%E% SMI"

/*
 * ASSERTION:
 *  This D ditty tests the ability to perform both copyin and copyinstr.  We
 *  grab the value or pr_envp, read the first pointer from the user stack,
 *  and then copyinstr the first environment variable and print it.
 *
 * SECTION: Actions and Subroutines/copyin();
 * 	Actions and Subroutines/copyinstr();
 *	User Process Tracing/copyin() and copyinstr()
 */

BEGIN
/curpsinfo->pr_dmodel == PR_MODEL_ILP32/
{
	envp = *(uint32_t *)copyin(curpsinfo->pr_envp, sizeof (uint32_t));
	printf("envp[0] = \"%s\"", copyinstr(envp));
	exit(0);
}

BEGIN
/curpsinfo->pr_dmodel == PR_MODEL_LP64/
{
	envp = *(uint64_t *)copyin(curpsinfo->pr_envp, sizeof (uint64_t));
	printf("envp[0] = \"%s\"", copyinstr(envp));
	exit(0);
}
