#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#

#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"%Z%%M%	%I%	%E% SMI"
#

#
# ASSERTION: Mem probes should enable successfully.
#

if [ $# != 1 ]; then
	echo expected one argument: '<'dtrace-path'>'
	exit 2
fi

#
# Do not fail the test in a domU
#
if [ ! -c /dev/xen/privcmd ]; then
	exit 0
fi

dtrace=$1

script()
{
	$dtrace -qs /dev/stdin <<EOF
	dtrace:::BEGIN
	{
		exit(0);
	}

	xdt:mem::page-grant-map,
	xdt:mem::page-grant-unmap,
	xdt:mem::page-grant-transfer
	{}
EOF
}

script
status=$?

exit $status
