/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 *
 * Portions Copyright 2006-2008 John Birrell jb@freebsd.org
 *
 * $FreeBSD: releng/8.4/cddl/lib/libdtrace/net.d 179189 2008-05-22 04:26:42Z jb $
 */

/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#pragma ident	"%Z%%M%	%I%	%E% SMI"

/*
 * The conninfo_t structure should be used by all application protocal
 * providers as the first arguments to indicate some basic information
 * about the connection. This structure may be augmented to accomodate
 * the particularities of additional protocols in the future.
 */
typedef struct conninfo {
	string ci_local;	/* local host address */
	string ci_remote;	/* remote host address */
	string ci_protocol;	/* protocol (ipv4, ipv6, etc) */
} conninfo_t;
